package com.fp.persistence.parmas.soli;

import javax.persistence.Entity;

import java.sql.Timestamp;

import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMDECOMISOARMA*/
@Entity(name="TarmDecomisoArma")
@Table(name="TARMDECOMISOARMA")
public class TarmDecomisoArma extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmDecomisoArma
*/
@Id
@Column(name="CDECOMISOARMA" ,nullable=false, updatable=false)
private String pk;
@Column(name="CARMA", nullable=true)

/**
* codigo da la tabla TarmArma
*/
private String carma;

@Column(name="MOTIVODECOMISO", nullable=true)

/**
* Codigo de catalogo  01 Permiso Caducado, 02 Sin Papeles
*/
private String motivodecomiso;

@Column(name="MOTIVODECOMISOCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String motivodecomisocodigo;

@Column(name="ESTADO", nullable=true)

/**
* Codigo de catalogo  01 Decomisado, 02 Incautado
*/
private String estado;

@Column(name="ESTADOCODE", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de estados
*/
private String estadocode;

@Column(name="UNIDADMEDIDA", nullable=true)

/**
* Codigo de catalogo  01 Unidad, 02 Peso
*/
private String unidadmedida;

@Column(name="UNIDADMEDIDACODE", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de unidad
*/
private String unidadmedidacode;

@Column(name="CDECOMISO", nullable=true)

/**
* Codigo de la Tabla Decomiso
*/
private Long cdecomiso;

@Column(name="FDECOMISO", nullable=true)

/**
* fecha de registro del decomiso
*/
private Timestamp fdecomiso;

@Column(name="CANTIDAD", nullable=true)

/**
* cantidad decomisada
*/
private BigDecimal cantidad;

@Column(name="OBSERVACION", nullable=true)

/**
* observación del decomiso
*/
private String observacion;

@Column(name="CCUSTEMP", nullable=true)

/**
* null
*/
private String ccustemp;

@Column(name="ADESTRUIRSE", nullable=true)

/**
* Codigo de catalogo  para indicar si el arma esta en algun reporte del flujo de armas a destruir
*/
private String adestruirse;

@Column(name="ADESTRUIRSECODE", nullable=true)

/**
* CatalogCode  para indicar si el arma esta en algun reporte del flujo de armas a destruir
*/
private String adestruirsecode;

@Column(name="ESTADOANTERIOR", nullable=true)

/**
* Tabla que contiene los decomisos y la custodia temporal de las armas asignadas a la persona
*/
private String estadoanterior;

@Column(name="TIPOREGISTROANTERIOR", nullable=true)

/**
* CAmpo que registra el estado anterior del registro arma para cuando se devuelva regrese a su estado anterior
*/
private String tiporegistroanterior;

@Column(name="ENBODEGA", nullable=true)

/**
* CAMPO QUE INDICA QUE EL TECNICO DE ALMACENAMIENTO CONFIRMO QUE EL ARMA DECOMISADA SE ENCUENTRA EN BODEGA
*/
private String enbodega;

@Column(name="CDECOMISOARMATRANSACCION", nullable=true)

/**
* Clave foranea a TARMDECOMISOARMATRANSACCION
*/
private Long cdecomisoarmatransaccion;

@Column(name="CDECARMTRANRECEPCION", nullable=true)

/**
* Codigo de la tabla TarmDecomisoArmaTransaccion para obtener el numero de transaccion de recepcion
*/
private Long cdecarmtranrecepcion;


/**
* Operacion actual de la transaccion
*/
@Column(name="COPERACIONTRANSACCION", nullable=true)
private String coperaciontransaccion;



/**Contructor por defecto*/
public TarmDecomisoArma(){
}
/**Contructor de TarmDecomisoArma
@param pPk Clave Primaria del entity
*/
public TarmDecomisoArma(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmDecomisoArma
*/
public static TarmDecomisoArma find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmDecomisoArma obj = pEntityManager.find(TarmDecomisoArma.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmDecomisoArma
@return El objeto que referencia a la Clave primaria de TarmDecomisoArma
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmDecomisoArma
@param pPk El objeto que referencia a la nueva Clave primaria de TarmDecomisoArma
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de motivodecomiso
@return valor de motivodecomiso*/
public String getMotivodecomiso(){
  return motivodecomiso;
}
/**Fija el valor de motivodecomiso
@param pMotivodecomiso nuevo Valor de motivodecomiso*/
public void setMotivodecomiso(String pMotivodecomiso){
  motivodecomiso=pMotivodecomiso;
}

/**Obtiene el valor de motivodecomisocodigo
@return valor de motivodecomisocodigo*/
public String getMotivodecomisocodigo(){
  return motivodecomisocodigo;
}
/**Fija el valor de motivodecomisocodigo
@param pMotivodecomisocodigo nuevo Valor de motivodecomisocodigo*/
public void setMotivodecomisocodigo(String pMotivodecomisocodigo){
  motivodecomisocodigo=pMotivodecomisocodigo;
}

/**Obtiene el valor de estado
@return valor de estado*/
public String getEstado(){
  return estado;
}
/**Fija el valor de estado
@param pEstado nuevo Valor de estado*/
public void setEstado(String pEstado){
  estado=pEstado;
}

/**Obtiene el valor de estadocode
@return valor de estadocode*/
public String getEstadocode(){
  return estadocode;
}
/**Fija el valor de estadocode
@param pEstadocode nuevo Valor de estadocode*/
public void setEstadocode(String pEstadocode){
  estadocode=pEstadocode;
}

/**Obtiene el valor de unidadmedida
@return valor de unidadmedida*/
public String getUnidadmedida(){
  return unidadmedida;
}
/**Fija el valor de unidadmedida
@param pUnidadmedida nuevo Valor de unidadmedida*/
public void setUnidadmedida(String pUnidadmedida){
  unidadmedida=pUnidadmedida;
}

/**Obtiene el valor de unidadmedidacode
@return valor de unidadmedidacode*/
public String getUnidadmedidacode(){
  return unidadmedidacode;
}
/**Fija el valor de unidadmedidacode
@param pUnidadmedidacode nuevo Valor de unidadmedidacode*/
public void setUnidadmedidacode(String pUnidadmedidacode){
  unidadmedidacode=pUnidadmedidacode;
}

/**Obtiene el valor de cdecomiso
@return valor de cdecomiso*/
public Long getCdecomiso(){
  return cdecomiso;
}
/**Fija el valor de cdecomiso
@param pCdecomiso nuevo Valor de cdecomiso*/
public void setCdecomiso(Long pCdecomiso){
  cdecomiso=pCdecomiso;
}

/**Obtiene el valor de fdecomiso
@return valor de fdecomiso*/
public Timestamp getFdecomiso(){
  return fdecomiso;
}
/**Fija el valor de fdecomiso
@param pFdecomiso nuevo Valor de fdecomiso*/
public void setFdecomiso(Timestamp pFdecomiso){
  fdecomiso=pFdecomiso;
}

/**Obtiene el valor de cantidad
@return valor de cantidad*/
public BigDecimal getCantidad(){
  return cantidad;
}
/**Fija el valor de cantidad
@param pCantidad nuevo Valor de cantidad*/
public void setCantidad(BigDecimal pCantidad){
  cantidad=pCantidad;
}

/**Obtiene el valor de observacion
@return valor de observacion*/
public String getObservacion(){
  return observacion;
}
/**Fija el valor de observacion
@param pObservacion nuevo Valor de observacion*/
public void setObservacion(String pObservacion){
  observacion=pObservacion;
}

/**Obtiene el valor de ccustemp
@return valor de ccustemp*/
public String getCcustemp(){
  return ccustemp;
}
/**Fija el valor de ccustemp
@param pCcustemp nuevo Valor de ccustemp*/
public void setCcustemp(String pCcustemp){
  ccustemp=pCcustemp;
}

/**Obtiene el valor de adestruirse
@return valor de adestruirse*/
public String getAdestruirse(){
  return adestruirse;
}
/**Fija el valor de adestruirse
@param pAdestruirse nuevo Valor de adestruirse*/
public void setAdestruirse(String pAdestruirse){
  adestruirse=pAdestruirse;
}

/**Obtiene el valor de adestruirsecode
@return valor de adestruirsecode*/
public String getAdestruirsecode(){
  return adestruirsecode;
}
/**Fija el valor de adestruirsecode
@param pAdestruirsecode nuevo Valor de adestruirsecode*/
public void setAdestruirsecode(String pAdestruirsecode){
  adestruirsecode=pAdestruirsecode;
}

/**Obtiene el valor de estadoanterior
@return valor de estadoanterior*/
public String getEstadoanterior(){
  return estadoanterior;
}
/**Fija el valor de estadoanterior
@param pEstadoanterior nuevo Valor de estadoanterior*/
public void setEstadoanterior(String pEstadoanterior){
  estadoanterior=pEstadoanterior;
}

/**Obtiene el valor de tiporegistroanterior
@return valor de tiporegistroanterior*/
public String getTiporegistroanterior(){
  return tiporegistroanterior;
}
/**Fija el valor de tiporegistroanterior
@param pTiporegistroanterior nuevo Valor de tiporegistroanterior*/
public void setTiporegistroanterior(String pTiporegistroanterior){
  tiporegistroanterior=pTiporegistroanterior;
}

/**Obtiene el valor de enbodega
@return valor de enbodega*/
public String getEnbodega(){
  return enbodega;
}
/**Fija el valor de enbodega
@param pEnbodega nuevo Valor de enbodega*/
public void setEnbodega(String pEnbodega){
  enbodega=pEnbodega;
}

/**Obtiene el valor de cdecomisoarmatransaccion
@return valor de cdecomisoarmatransaccion*/
public Long getCdecomisoarmatransaccion(){
  return cdecomisoarmatransaccion;
}
/**Fija el valor de cdecomisoarmatransaccion
@param pCdecomisoarmatransaccion nuevo Valor de cdecomisoarmatransaccion*/
public void setCdecomisoarmatransaccion(Long pCdecomisoarmatransaccion){
  cdecomisoarmatransaccion=pCdecomisoarmatransaccion;
}

/**Obtiene el valor de cdecarmtranrecepcion
@return valor de cdecarmtranrecepcion*/
public Long getCdecarmtranrecepcion(){
  return cdecarmtranrecepcion;
}
/**Fija el valor de cdecarmtranrecepcion
@param pCdecarmtranrecepcion nuevo Valor de cdecarmtranrecepcion*/
public void setCdecarmtranrecepcion(Long pCdecarmtranrecepcion){
  cdecarmtranrecepcion=pCdecarmtranrecepcion;
}

/**
 * @return the coperaciontransaccion
 */
public String getCoperaciontransaccion() {
	return coperaciontransaccion;
}
/**
 * @param coperaciontransaccion the coperaciontransaccion to set
 */
public void setCoperaciontransaccion(String coperaciontransaccion) {
	this.coperaciontransaccion = coperaciontransaccion;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmDecomisoArma))return false;
    TarmDecomisoArma that = (TarmDecomisoArma) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmDecomisoArma
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmDecomisoArma
*/
public Object createInstance(){
 TarmDecomisoArma instance=new TarmDecomisoArma();	
 return instance;
}
/**Clona la entidad TarmDecomisoArma
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmDecomisoArma p=(TarmDecomisoArma)this.clone();
  return p;
}
}
